Program Computer_AI;
{hello}
{****************************************************************************
 Master of the Empire AI Module v1.5c

}


Const
  {***** DO NOT CHANGE THESE VALUES!!! *****}
  infantry = 100;
  tank = 101;
  bomber = 102;
  sub = 103;
  fighter = 104;
  sea_transport = 105;
  air_transport = 106;
  spy = 107;
  destroyer = 108;
  battleship = 109;
  cruiser = 110;
  engineer = 111;
  paratrooper = 112;
  aircraft_carrier = 113;
  none = 114;

  OTexplore = 114;
  OTattack_unit = 115;
  OTattack_city = 116;
  OTsentry = 117;
  OTescort = 118;
  OTtransport = 119;
  OTgoto_city = 120;
  OTgoto_resource = 121;
  OTdisband = 122;
  OTresource_sentry = 123;
  OTboard_transport = 124;
  OTleave_port = 125;
  OTwaypoints = 126;
  NEED_ORDERTYPE = 127;
  OTGOTOLOCATION = 128;

  NORTH    =  0;
  SOUTH    =  4;
  EAST     =  2;
  WEST     =  6;
  NORTHEAST=  1;
  SOUTHEAST = 3;
  NORTHWEST=  7;
  SOUTHWEST=  5;

  MAX_UNITS = 199;

  stored_oil = 4;
  stored_coal = 5;
  stored_uranium = 2;
  stored_gold = 1;
  stored_minerals = 3;
  stored_food = 6;

  access_oil = 12;
  access_coal = 13;
  access_uranium = 10;
  access_gold = 9;
  access_minerals = 11;
  access_food = 14;

  port_city = 15;
  owner = 16;
  c_type = 17;
  zubles = 7;
  location = 8;
  prod = 18;
  unit_bought = 19;
  tax_rate = 20;
  online = 21;

  ACCESS = 1;
  STORED = 2;

  SACK   = 1;
  RAZE   = 2;
  OCCUPY = 3;

  UNIT_TYPE         = 1;
  UNIT_LOC          = 2;
  UNIT_ACTIVE       = 3;
  ORDERTYPE         = 4;
  BUILD_ORIGIN      = 5;
  UNIT_HITS         = 6;
  UNIT_RANGE        = 7;
  UNIT_TRANGE       = 8;
  UNIT_CRANGE       = 9;
  TROOP_CARGO       = 10;
  TANK_CARGO        = 11;
  AIRCRAFT_CARGO    = 12;
  ENGINEER_CARGO    = 13;
  UNIT_DAMAGED      = 14;
  BATTLES_WON       = 15;
  ATTACK_MOD        = 16;
  DEFENSIVE_MOD     = 17;
  HITPOINT_MOD      = 18;

  TERRAIN = 1;
  GRASS = 2;
  FOREST = 3;
  MOUNTAIN = 4;
  WATER = 5;


  rGOLD     =1;
  rURANIUM  =2;
  rMINERALS =3;
  rOIL      =4;
  rCOAL     =5;
  rFOOD     =6;


  {Definitions for different types of cities}
  CAPITAL           = 1;
  CITY              = 2;
  TOWN              = 3;
  VILLAGE           = 4;

  IDPLAYER            = 0;
  IDNEUTRAL           = 2;
  IDCOMPUTER1         = 1;
  IDCOMPUTER2         = 3;
  IDCOMPUTER3         = 4;
  IDRAZED             = 99;
  {***** DO NOT CHANGE THESE VALUES!!! *****}


  NEUTRAL = 0;
  PEACE   = 1;
  WAR     = 2;

type

 {Used to determine the movement capabilities of a unit}
 movetype = Record
	      canmove : boolean;
	      explored: boolean;
	      ranking : integer;
	    end;

 {Records information on a city that is used in the AI}
 cityinfo = Record
	      location : integer;
	      port_city : boolean;
	      owner : integer;

	      {tracks production of units in city}
	      production : array[1..10] of integer;
	      curprod : integer;

	      {Resource tracking - who's got the resources!}
	      oil : array[1..2] of integer;
	      coal : array[1..2] of integer;
	      uranium : array[1..2] of integer;
	      gold : array[1..2] of integer;
	      minerals : array[1..2] of integer;
	      food : array[1..2] of integer;

	      zubles : integer;
	    end;


 unittype = Record
	      ordertype : integer;  {stores current ordertype}
	      workuntilturn : integer; {holds counter to see how many turns are remaining}
	      groupwith : integer; {latches this unit with another unit for
				    massing :) }
	      destination : integer; {records destination computer wants to move to}
	      destnum : integer;
	      pnum : integer;
	      lastlocation : integer;
	      enroute : integer;
	      guard_city: integer;
	    end;

 pi_type = Record
	     num_cities_owned : integer;
	     num_units_owned : integer;
	   end;

 globalot_type = Record
		   orders : integer;
		   enemyrank : array[0..4] of integer;
		 end;
var
  current_player : integer;
  mt_array : array[0..7] of movetype; {tracks movement in different directions}
  turn : integer;  {stores current turn number}
  units : array[0..4,0..MAX_UNITS] of unittype;
  cities : array[0..50] of cityinfo;
  x : integer;
  global_ordertype : globalot_type;
  player_information : array[0..4] of pi_type;
  rml : array[0..400] of integer;
  production : array[INFANTRY..AIRCRAFT_CARRIER] of integer;
  resources : array[rGOLD..rFOOD] of integer;

Procedure Save_Game;
var
 x,y : integer;

Begin
  fout(current_player);
  fout(turn);
  fout(global_ordertype.orders);
  fout(global_ordertype.enemyrank[0]);
  fout(global_ordertype.enemyrank[1]);
  fout(global_ordertype.enemyrank[2]);
  fout(global_ordertype.enemyrank[3]);
  fout(global_ordertype.enemyrank[4]);

  for x := 0 to 4 do
    for y := 0 to MAX_UNITS do
     Begin
       fout(units[x][y].ordertype);
       fout(units[x][y].workuntilturn);
       fout(units[x][y].groupwith);
       fout(units[x][y].destination);
       fout(units[x][y].destnum);
       fout(units[x][y].pnum);
       fout(units[x][y].lastlocation);
       fout(units[x][y].enroute);
       fout(units[x][y].guard_city);
     end;
  for x := 0 to MAX_CITIES do
    Begin
      fout(cities[x].location);
      fout(cities[x].port_city);
      fout(cities[x].owner);
      for y := 1 to 10 do
	fout(cities[x].production[y]);
      fout(cities[x].curprod);
      for y := 1 to 2 do
	Begin
	  fout(cities[x].oil[y]);
	  fout(cities[x].coal[y]);
	  fout(cities[x].uranium[y]);
	  fout(cities[x].gold[y]);
	  fout(cities[x].minerals[y]);
	  fout(cities[x].food[y]);
	end;
      fout(cities[x].zubles);
    end;
 for x := 0 to 400 do fout(rml[x]);
 for x := INFANTRY to AIRCRAFT_CARRIER do fout(production[x]);
 for x := rGOLD to rFOOD do fout(resources[x]);
end;

Procedure Load_Game;
var
 x,y : integer;
Begin
  fin(current_player);
  fin(turn);
  fin(global_ordertype.orders);
  fin(global_ordertype.enemyrank[0]);
  fin(global_ordertype.enemyrank[1]);
  fin(global_ordertype.enemyrank[2]);
  fin(global_ordertype.enemyrank[3]);
  fin(global_ordertype.enemyrank[4]);

  for x := 0 to 4 do
    for y := 0 to MAX_UNITS do
     Begin
       fin(units[x][y].ordertype);
       fin(units[x][y].workuntilturn);
       fin(units[x][y].groupwith);
       fin(units[x][y].destination);
       fin(units[x][y].destnum);
       fin(units[x][y].pnum);
       fin(units[x][y].lastlocation);
       fin(units[x][y].enroute);
       fin(units[x][y].guard_city);
     end;
  for x := 0 to MAX_CITIES do
    Begin
      fin(cities[x].location);
      fin(cities[x].port_city);
      fin(cities[x].owner);
      for y := 1 to 10 do
	fin(cities[x].production[y]);
      fin(cities[x].curprod);
      for y := 1 to 2 do
	Begin
	  fin(cities[x].oil[y]);
	  fin(cities[x].coal[y]);
	  fin(cities[x].uranium[y]);
	  fin(cities[x].gold[y]);
	  fin(cities[x].minerals[y]);
	  fin(cities[x].food[y]);
	end;
      fin(cities[x].zubles);
    end;
 for x := 0 to 400 do fin(rml[x]);
 for x := INFANTRY to AIRCRAFT_CARRIER do fin(production[x]);
 for x := rGOLD to rFOOD do fin(resources[x]);
end;


{Init_Movement -
  Identifies where the current unit can move from the current location.
  Also ranks each of the moves from 0-999 with 0 being the best possible
  move at the time and 999 being a VERY bad route or an impassible route}

Function Num_units(p:integer):integer;
var
 x : integer;
 nu : integer;
Begin
 nu := 0;
 for x := 0 to MAX_UNITS do
     if (unit_info(p,x,UNIT_ACTIVE)=1) then nu := nu + 1;
 num_units := nu;
end;

Function Num_cities(p:integer):integer;
var
 x : integer;
 nc : integer;
Begin
 nc := 0;
 for x := 0 to MAX_CITIES do
     if (city_info(x,OWNER)=p) then nc := nc + 1;
 num_cities := nc;
end;


Function MPS(ut,loc:integer):integer;
var
  m,f,g,w: boolean;
Begin
 m := map_info(loc,MOUNTAIN);
 f := map_info(loc,FOREST);
 g := map_info(loc,GRASS);
 w := map_info(loc,WATER);

 if (ut=INFANTRY) or (ut=TANK) or (ut=SPY) or (ut=ENGINEER) or (ut=PARATROOPER) then
  Begin
    if (g) then mps := 2 else
    if (f) then mps := 3 else
    if (w) then mps := 100 else
    if (m) then mps := 100;
  end else mps := 1;
end;

Function loc_ok(loc:integer):boolean;
var
 x,y : integer;
Begin
 x := loc mod 100;
 y := loc div 100;
 if (x>6) and (x<87) and (y>700) and (y<98) then loc_ok := true else loc_ok := false;
end;

Procedure Init_Movement(cu:integer);
var
 location : integer;
 y : integer;
 xtest : integer;
 ut : integer;
 locmod : integer;
 mi : integer;
 newloc : integer;

Begin
  location := unit_info(current_player,cu,unit_loc);  {store units location}
  ut := unit_info(current_player,cu,unit_type);

  for xtest := 0 to 7 do
    Begin
      case xtest of
       NORTH : locmod := -100;
       SOUTH : locmod := 100;
       EAST  : locmod := 1;
       WEST  : locmod := -1;
       NORTHEAST : locmod := -99;
       NORTHWEST : locmod := -101;
       SOUTHEAST : locmod := 101;
       SOUTHWEST : locmod := 99;
      end;


      mt_array[xtest].canmove  := can_move(cu,xtest);
      mt_array[xtest].explored := loc_explored(location+(locmod*2));
      mt_array[xtest].ranking := 0;

      if not(mt_array[xtest].canmove) then
	  mt_array[xtest].ranking := 999 else
      Begin

	if (mt_array[xtest].explored) then mt_array[xtest].ranking := mt_array[x].ranking-1 else
				   mt_array[xtest].ranking := mt_array[xtest].ranking+1;

	y := 1;
	if loc_ok((y*locmod)+location) then
	  Begin
	    newloc := (y*locmod)+location;
	    if (ut=INFANTRY) or (ut=TANK) or (ut=SPY) or (ut=ENGINEER) or (ut=PARATROOPER) then
	      Begin
		if (land_at_loc(newloc)) and (mps(ut,newloc)<100) and not(loc_explored(newloc)) then mt_array[x].ranking := mt_array[x].ranking-1 else
						   mt_array[xtest].ranking := mt_array[xtest].ranking+1;
	      end else
	    if (ut=BOMBER) or (ut=AIR_TRANSPORT) or (ut=FIGHTER) then
	      if not(loc_explored(newloc)) then mt_array[xtest].ranking := mt_array[xtest].ranking - 1 else
	      Begin
		if not(land_at_loc(newloc)) and not(loc_explored(newloc)) then mt_array[x].ranking := mt_array[xtest].ranking-1 else
						      mt_array[x].ranking := mt_array[xtest].ranking+1;
	      end;
	    end;
	end;
    end;

end;

{This procedure handles exploration of units}
Procedure explore(cu : integer);
var
 done : boolean;       {tracks if movement is finished}
 moved : boolean;      {result holder when actual move takes place}
 mp : integer;         {movement_points holder}
 location : integer;   {holds current location of unit}
 rnd : integer;        {holds random #}
 loop : integer;
 best_move : integer;
 bmn : integer;
 c : integer;
 rmlnum : integer;
Begin
  done := false;
  repeat
    location := unit_info(current_player,cu,unit_loc)+(random(1000)-500);
     if (mps(unit_info(current_player,cu,unit_type),location)<100) then
	Begin
	  units[current_player][cu].destination := location;
	  units[current_player][cu].destnum := 0;
	  units[current_player][cu].ordertype := OTGOTOLOCATION;
	  units[current_player][cu].workuntilturn := 3;
	  done := true;
	end;
  until (done);
end;

{This procedure will handle production for the current player's cities}
Procedure handle_production;
var
 a,x : integer;
 prod_info : array[INFANTRY..AIRCRAFT_CARRIER] of integer;
 totalunits : integer;
 fst : integer;

Function Farthest:integer;
var
 y : integer;
 ft,ftn : integer;
 x : integer;
Begin
 ft := 100;
 ftn := 0;
 for y := INFANTRY to AIRCRAFT_CARRIER do
   if prod_info[y]<ft then
     Begin
       ft := prod_info[y];
       ftn := y;
     end;
 if ftn=100 then ftn := TANK;
 farthest := ftn;
end;

Begin
 for x := infantry to aircraft_carrier do
   prod_info[x] := 0;

 totalunits := 0;
 for x := 0 to MAX_UNITS do
   if active(x) then
   Begin
     a := unit_info(current_player,x,UNIT_TYPE);
     if (a>=INFANTRY) and (a<=AIRCRAFT_CARRIER) then
      Begin
	prod_info[a] := prod_info[a]+1;
	totalunits := totalunits+1;
      end;
   end;

 for x := INFANTRY to AIRCRAFT_CARRIER do
     Begin
       if (prod_info[x]>0) then
       prod_info[x] := trunc((prod_info[x]/100)*100);
     end;
 for x := 0 to MAX_CITIES do
   if (cities[x].owner=current_player) and (city_info(x,PROD)=NONE) then
     Begin
       if (city_info(x,PORT_CITY)>0) then
	 Begin
	   for a := INFANTRY to AIRCRAFT_CARRIER do
	     if (a=DESTROYER) or (a=BATTLESHIP) or (a=CRUISER) or
		(a=SEA_TRANSPORT) or (a=SUB) then
	     if prod_info[a]<production[a] then assign_production(x,a);
	 end else
	 Begin
	   fst := farthest;
	   if (fst=AIRCRAFT_CARRIER) or (fst=SEA_TRANSPORT) or
	      (fst=DESTROYER) or (fst=BATTLESHIP) or (fst=SUB) or
	      (fst=CRUISER) then fst:= AIR_TRANSPORT;
	      if prod_info[fst]<production[fst] then assign_production(x,fst);
	 end;
     end;
end;

{This procedure will handle the buying and selling of resources}
Procedure handle_global_market;
var
 x,y : integer;
 cres : array[rgold..rfood] of integer;
 br : boolean;
Begin
 for x := 0 to MAX_CITIES do
   if (cities[x].owner=current_player) and (city_info(x,ZUBLES)>ailevel*25) then
   Begin
     for y := rgold to rfood do
       cres[y] := city_info(x,y);
     for y := rgold to rfood do
	 if (cres[y]<resources[y]) then br := buy_resource(x,y,random(4));
   end;
end;

Function Capital_City(p:integer):integer;
var
 x : integer;
Begin
 capital_city := 9999;
 for x := 0 to MAX_CITIES do
   Begin
     if (city_info(x,owner)=p) and (city_info(x,c_type)=CAPITAL) then
       capital_city := x;
   end;
end;

{This procedure will handle the buying of new units for each city if necessary}
Procedure handle_buying_units;
var
 cc : integer;
 modifier:integer;
 ceut,
 ceud,
 ceu : array[0..4] of integer;
 y : integer;
 nuo : integer;
 ok : integer;
Begin
 nuo := num_units(current_player);
 for x := 0 to MAX_CITIES do
   if (cities[x].owner=current_player) then
  Begin
    if closest_unit(current_player,cities[x].location,AIR_TRANSPORT)<ailevel then
      if random(100)>75 then ok := buy_unit(x,PARATROOPER);
    if (nuo<(ailevel div 2)) then
      if random(2)=1 then
	  ok := buy_unit(x,TANK) else ok := buy_unit(x,INFANTRY);
    if ok<=MAX_UNITS then nuo := nuo+1;
  end;
 for x := 0 to MAX_CITIES do
   if cities[x].owner=current_player then
   Begin
     for y := 0 to 4 do
       Begin
	 ceu[y] := closest_enemy_unit(y,cities[x].location);
	 if ceu[y]<=MAX_UNITS then
	   Begin
	     ceut[y] := unit_info(y,ceu[y],UNIT_TYPE);
	     ceud[y] := loc_distance(cities[x].location,unit_info(y,ceu[y],UNIT_LOC));
	   end;
	 ceu[current_player] := 9999;
	 if ceu[y]<=MAX_UNITS then
	   if (ceud[y]<(ailevel div 3)) then
	       Begin
		 cc := buy_unit(x,ceut[y]);
		 if cc<=MAX_UNITS then
		   Begin
		     units[current_player][cc].ordertype := OTATTACK_UNIT;
		     units[current_player][cc].workuntilturn := ailevel div 2;
		     case random(8) of
		      0 : modifier := -1;
		      1 : modifier := 1;
		      2 : modifier := -100;
		      3 : modifier := 100;
		      4 : modifier := 99;
		      5 : modifier := -99;
		      6 : modifier := 101;
		      7 : modifier := -101;
		     end;
		     units[current_player][cc].destination := unit_info(y,ceu[y],UNIT_LOC)+modifier;
		     units[current_player][cc].destnum := ceu[y];
		     units[current_player][cc].pnum := y;
		   end;
	 end;
       end;
   end;
end;

Procedure gotocity(cu:integer);
var
 ul : integer;
 return : boolean;
Begin
  return := move_to(cu,units[current_player][cu].destination);
  ul := unit_info(current_player,cu,unit_loc);
  if (loc_distance(ul,cities[units[current_player][cu].destnum].location)=0) then
      units[current_player][cu].ordertype := NEED_ORDERTYPE;
end;

Procedure gotolocation(cu:integer);
var
 ul : integer;
 return : boolean;
Begin
  return := move_to(cu,units[current_player][cu].destination);
  ul := unit_info(current_player,cu,unit_loc);
  if (loc_distance(ul,units[current_player][cu].destination)=0) then
      units[current_player][cu].ordertype := OTEXPLORE;
end;

Procedure assemble_transport(cu:integer);
var
 x : integer;
 cun : integer;
 ut,ul : integer;
 tc :  integer;
Begin
 ul := unit_info(current_player,cu,unit_loc);
 ut := unit_info(current_player,cu,unit_type);

 tc := unit_info(current_player,cu,troop_cargo);
 tc := tc + units[current_player][cu].enroute;

 if (tc<5) then
 Begin
   if (ut=SEA_TRANSPORT) then
     cun := closest_unit(current_player,ul,INFANTRY)
      else cun := closest_unit(current_player,ul,PARATROOPER);

   if (cun<=MAX_UNITS) then
    if (not(units[current_player][cun].ordertype=OTBOARD_TRANSPORT)) and
       (not(units[current_player][cun].ordertype=OTATTACK_CITY)) and
       (not(units[current_player][cun].ordertype=OTATTACK_UNIT)) and
       (not(units[current_player][cun].ordertype=OTSENTRY)) and
       (units[current_player][cun].enroute=0) then
     Begin
       units[current_player][cun].ordertype := OTBOARD_TRANSPORT;
       units[current_player][cun].destination := ul;
       units[current_player][cun].destnum := cu;
       units[current_player][cun].pnum := current_player;
       units[current_player][cu].enroute := units[current_player][cu].enroute+1;
       units[current_player][cu].workuntilturn := 3;
       units[current_player][cu].ordertype := OTSENTRY;
     end else
     if (units[current_player][cun].enroute>0) then
       units[current_player][cun].enroute := units[current_player][cun].enroute-1;
 end;

 if (unit_info(current_player,cu,unit_type)=SEA_TRANSPORT) then
 if (unit_info(current_player,cu,tank_cargo)+units[current_player][cu].enroute<5) then
  Begin
    cun := closest_unit(current_player,ul,TANK);
    if (cun<=MAX_UNITS) then
     if (not(units[current_player][cun].ordertype=OTBOARD_TRANSPORT)) and
	(not(units[current_player][cun].ordertype=OTATTACK_CITY)) and
	(not(units[current_player][cun].ordertype=OTATTACK_UNIT)) and
	(not(units[current_player][cun].ordertype=OTSENTRY)) and
	(units[current_player][cun].enroute=0) then
      Begin
	units[current_player][cun].ordertype := OTBOARD_TRANSPORT;
	units[current_player][cun].destination := ul;
	units[current_player][cun].destnum := cu;
	units[current_player][cun].pnum := current_player;
	units[current_player][cu].enroute :=units[current_player][cu].enroute+1;
	units[current_player][cu].workuntilturn := 3;
	units[current_player][cu].ordertype := OTSENTRY;
      end else
       if (units[current_player][cun].enroute>0) then
       units[current_player][cun].enroute := units[current_player][cun].enroute-1;
  end;
end;

Function check_impossible_move(cu:integer;return:boolean) : boolean;
var
 cpc : integer;
 nun : integer;
 cu1,cu2 : integer;
 ul : integer;
Begin
  ul := unit_info(current_player,cu,unit_loc);
  if (return) then check_impossible_move := false
  else
   Begin
     units[current_player][cu].ordertype := NEED_ORDERTYPE;
     check_impossible_move := true;
     cpc := closest_player_city(ul);
     if (cpc<=MAX_CITIES) then
      Begin
	nun := buy_unit(cpc,AIR_TRANSPORT);
	if (nun<=MAX_UNITS) then assemble_transport(nun);
      end;
     end;
end;

Procedure attackcity(cu:integer);
var
 ul : integer;
 return : boolean;
 u1,u2,u3 : integer;
 nu : integer;
 x,z,locmod : integer;
Begin
  if (city_info(units[current_player][cu].destnum,OWNER)=current_player) then
   Begin
      units[current_player][cu].ordertype := NEED_ORDERTYPE;
      units[current_player][cu].destnum := 0;
      units[current_player][cu].destination := 0;
      units[current_player][cu].workuntilturn := 3;
   end else
  Begin
    units[current_player][cu].destination := city_info(units[current_player][cu].destnum,location);
     for x := 0 to 7 do
      Begin
	case x of
	 NORTH : locmod := -100;
	 SOUTH : locmod := 100;
	 EAST  : locmod := 1;
	 WEST  : locmod := -1;
	 NORTHEAST : locmod := -99;
	 NORTHWEST : locmod := -101;
	 SOUTHEAST : locmod := 101;
	 SOUTHWEST : locmod := 99;
	end;
       if valid_path_position(unit_info(current_player,cu,unit_type),units[current_player][cu].destination+locmod) then z := x;
      end;
  if (z=9999) then
    Begin
      units[current_player][cu].ordertype := NEED_ORDERTYPE;
    end else
    Begin
      case z of
	 NORTH : locmod := -100;
	 SOUTH : locmod := 100;
	 EAST  : locmod := 1;
	 WEST  : locmod := -1;
	 NORTHEAST : locmod := -99;
	 NORTHWEST : locmod := -101;
	 SOUTHEAST : locmod := 101;
	 SOUTHWEST : locmod := 99;
	end;
   units[current_player][cu].destination := units[current_player][cu].destination+locmod;
   return := move_to(cu,units[current_player][cu].destination);
      if not(check_impossible_move(cu,return)) then
       Begin
	 ul := unit_info(current_player,cu,unit_loc);
	 if (loc_distance(ul,cities[units[current_player][cu].destnum].location)<2) then
	   Begin
	     return := attack_city(cu,units[current_player][cu].destnum,OCCUPY);
	     if not(return) or not(active(cu)) then units[current_player][cu].ordertype := NEED_ORDERTYPE else
	     Begin
	       set_city(units[current_player][cu].destnum,online,1);
	       assign_production(units[current_player][cu].destnum,NONE);
	     end;
	  end;
      end;
    end;
  end;
end;


Procedure attackunit(cu:integer);
var
 ul : integer;
 return : boolean;
 locmod : integer;
 z,x : integer;
Begin
 z :=  9999;
 units[current_player][cu].destination := unit_info(units[current_player][cu].pnum,units[current_player][cu].destnum,unit_loc);
     for x := 0 to 7 do
      Begin
	case x of
	 NORTH : locmod := -100;
	 SOUTH : locmod := 100;
	 EAST  : locmod := 1;
	 WEST  : locmod := -1;
	 NORTHEAST : locmod := -99;
	 NORTHWEST : locmod := -101;
	 SOUTHEAST : locmod := 101;
	 SOUTHWEST : locmod := 99;
	end;
       if valid_path_position(unit_info(current_player,cu,unit_type),units[current_player][cu].destination+locmod) then z := x;
      end;
  if (z=9999) then
    Begin
      units[current_player][cu].ordertype := NEED_ORDERTYPE;
    end else
  Begin
	case z of
	 NORTH : locmod := -100;
	 SOUTH : locmod := 100;
	 EAST  : locmod := 1;
	 WEST  : locmod := -1;
	 NORTHEAST : locmod := -99;
	 NORTHWEST : locmod := -101;
	 SOUTHEAST : locmod := 101;
	 SOUTHWEST : locmod := 99;
	end;
    units[current_player][cu].destination := units[current_player][cu].destination+locmod;
    return := move_to(cu,units[current_player][cu].destination);
    if not(check_impossible_move(cu,return)) then
    Begin
      ul := unit_info(current_player,cu,unit_loc);
      if (loc_distance(ul,units[current_player][cu].destination)=0) then
	Begin
	  return := attack_unit(cu,units[current_player][cu].pnum,units[current_player][cu].destnum);
	  if return then
	   Begin
	     units[current_player][cu].ordertype := NEED_ORDERTYPE;
	     units[current_player][cu].pnum := current_player;
	     units[current_player][cu].destination := 0;
	   end;
	end;
    end;
  end;
end;

Procedure Scan_Around(cu:integer);
var
 x : integer;
 ut,ul : integer;
 rnd : integer;
 cec : integer;
 ceu : array[0..4] of integer;

 leu : integer;
 leud : integer;
 leup : integer;
 leut : integer;
 modifier : integer;
 d : integer;
 ts : integer;
 cc : integer;

Begin
  cc := capital_city(current_player);

  ut := unit_info(current_player,cu,unit_type);
  ul := unit_info(current_player,cu,unit_loc); {get location of current unit}

 if (ut=AIR_TRANSPORT) or (ut=SEA_TRANSPORT) then
  Begin
    if (units[current_player][cu].enroute=0) then assemble_transport(cu);
  end else
  Begin
  cec := closest_enemy_city(ul); {find the closest enemy city}

  leu := 999;
  leud := 9999;

  for x := 0 to 4 do   {find each of the closest units!}
      if (current_player<>x) then
      Begin
	ceu[x] := closest_enemy_unit(x,ul);
	d := loc_distance(unit_info(current_player,cu,UNIT_LOC),unit_info(x,ceu[x],UNIT_LOC));
	if (d<leud) then
	  Begin
	    leud := d;
	    leu := ceu[x];
	    leup := x;
	    leut := unit_info(leup,leu,UNIT_TYPE);
	  end;
     end;

  ts := treaty_status(current_player,leup);

  if leud<(ailevel div 2) then global_ordertype.orders := OTATTACK_UNIT;

  if (random(100)>95) and (cc<=MAX_CITIES) and (unit_info(current_player,cu,unit_type)=TANK) then
    Begin
      units[current_player][cu].ordertype := OTGOTOLOCATION;
      units[current_player][cu].destnum := cc;
      units[current_player][cu].destination := city_info(cc,LOCATION);
      units[current_player][cu].workuntilturn := random(5)+1;
    end else
  if global_ordertype.orders=OTEXPLORE then
    Begin
      units[current_player][cu].ordertype := OTEXPLORE;
      units[current_player][cu].workuntilturn := random(3)+1;
    end else
  if (global_ordertype.orders=OTATTACK_CITY) and not(cec=999) and
     ((ts=WAR) or (ts=neutral)) and (can_attack_city(cu)) then
    Begin
      units[current_player][cu].ordertype := OTATTACK_CITY;
      units[current_player][cu].destination := city_info(cec,LOCATION);
      units[current_player][cu].destnum := cec;
    end else
  if (global_ordertype.orders=OTATTACK_UNIT) and not(leu=999) and
     ((ts=WAR) or (ts=NEUTRAL)) then
    Begin
      units[current_player][cu].ordertype := OTATTACK_UNIT;
      case random(8) of
	0 : modifier := -1;
	1 : modifier := 1;
	2 : modifier := -100;
	3 : modifier := 100;
	4 : modifier := 99;
	5 : modifier := -99;
	6 : modifier := 101;
	7 : modifier := -101;
      end;
      units[current_player][cu].destination := unit_info(leup,leu,UNIT_LOC)+modifier;
      units[current_player][cu].destnum := leu;
      units[current_player][cu].pnum := leup;
    end else
    Begin
       units[current_player][cu].ordertype := OTEXPLORE;
       units[current_player][cu].workuntilturn := random(3)+1;
    end;
  end;
end;

Procedure TransportRoutine(cu:integer);
var
 loc : integer;
 locmod : integer;
 z,x : integer;
 ok : boolean;
 oknum : integer;
 cpc : integer;
 destpos : integer;
Begin
  if (unit_info(current_player,cu,unit_type)=SEA_TRANSPORT) then
  cpc := closest_port_city(unit_info(current_player,cu,unit_loc)) else
  cpc := closest_enemy_city(unit_info(current_player,cu,unit_loc));
  if cpc<=MAX_CITIES then
   Begin
     for x := 0 to 7 do
      Begin
	case x of
	 NORTH : locmod := -100;
	 SOUTH : locmod := 100;
	 EAST  : locmod := 1;
	 WEST  : locmod := -1;
	 NORTHEAST : locmod := -99;
	 NORTHWEST : locmod := -101;
	 SOUTHEAST : locmod := 101;
	 SOUTHWEST : locmod := 99;
	end;
	if not land_at_loc(city_info(cpc,location)+locmod) then
	  units[current_player][cu].destination := city_info(cpc,location)+locmod;
      end;
     units[current_player][cu].destnum := cpc;
     gotolocation(cu);
   end else explore(cu);

  loc := unit_info(current_player,cu,UNIT_LOC);

    z := 9999;
     for x := 0 to 7 do
      Begin
	case x of
	 NORTH : locmod := -100;
	 SOUTH : locmod := 100;
	 EAST  : locmod := 1;
	 WEST  : locmod := -1;
	 NORTHEAST : locmod := -99;
	 NORTHWEST : locmod := -101;
	 SOUTHEAST : locmod := 101;
	 SOUTHWEST : locmod := 99;
	end;
       if valid_path_position(INFANTRY,loc+locmod) then z := x;
    end;
  if (z<9999) then
    Begin
	case z of
	 NORTH : locmod := -100;
	 SOUTH : locmod := 100;
	 EAST  : locmod := 1;
	 WEST  : locmod := -1;
	 NORTHEAST : locmod := -99;
	 NORTHWEST : locmod := -101;
	 SOUTHEAST : locmod := 101;
	 SOUTHWEST : locmod := 99;
	end;
     if (unit_info(current_player,cu,TANK_CARGO)>0) then
	   Begin
	     oknum := unload_transport(current_player,cu,TANK_CARGO,loc+locmod);
	     units[current_player][oknum].enroute := 3;
	     scan_around(oknum);
	     {units[current_player][oknum].ordertype := NEED_ORDERTYPE;}
	   end else
     if (unit_info(current_player,cu,TROOP_CARGO)>0) then
	   Begin
	     oknum := unload_transport(current_player,cu,TROOP_CARGO,loc+locmod);
	     {units[current_player][oknum].ordertype := NEED_ORDERTYPE;}
	     units[current_player][oknum].enroute := 3;
	     scan_around(oknum);
	   end;
    end;
end;

Procedure gototransport(cu:integer);
var
 return : boolean;
 ul : integer;
 x,z : integer;
 locmod : integer;
Begin
 z :=  9999;
 units[current_player][cu].destination := unit_info(units[current_player][cu].pnum,units[current_player][cu].destnum,unit_loc);
     for x := 0 to 7 do
      Begin
	case x of
	 NORTH : locmod := -100;
	 SOUTH : locmod := 100;
	 EAST  : locmod := 1;
	 WEST  : locmod := -1;
	 NORTHEAST : locmod := -99;
	 NORTHWEST : locmod := -101;
	 SOUTHEAST : locmod := 101;
	 SOUTHWEST : locmod := 99;
	end;
       if valid_path_position(INFANTRY,units[current_player][cu].destination+locmod) then z := x;
      end;
  if (z=9999) then
    Begin
      units[current_player][cu].ordertype := NEED_ORDERTYPE;
    end else
  Begin
	case z of
	 NORTH : locmod := -100;
	 SOUTH : locmod := 100;
	 EAST  : locmod := 1;
	 WEST  : locmod := -1;
	 NORTHEAST : locmod := -99;
	 NORTHWEST : locmod := -101;
	 SOUTHEAST : locmod := 101;
	 SOUTHWEST : locmod := 99;
	end;
   units[current_player][cu].destination := units[current_player][cu].destination+locmod;
   return := move_to(cu,units[current_player][cu].destination);
   ul := unit_info(current_player,cu,unit_loc);
    if (loc_distance(ul,units[current_player][cu].destination)=0) then
      Begin
	return := board_transport(current_player,cu,units[current_player][cu].destnum);
	if (return) then
	Begin
	  x := units[current_player][units[current_player][cu].destnum].enroute-1;
	  units[current_player][units[current_player][cu].destnum].enroute := x;
	  units[current_player][cu].ordertype := need_ordertype;
	end;
      end;
  end;
end;

Procedure transport_sentry(cu:integer);
Begin
  assemble_transport(cu);
  if (units[current_player][cu].workuntilturn=0) and ( (unit_info(current_player,cu,troop_cargo)>0) or ( unit_info(current_player,cu,tank_cargo)>0) ) then
       Begin
	 units[current_player][cu].workuntilturn := 20;
	 units[current_player][cu].ordertype := OTLEAVE_PORT;
	 transportroutine(cu);
       end;

end;

Procedure sentry(cu:integer);
var
 x : integer;
 ut,ul : integer;
 rnd : integer;
 cec : integer;
 ceu : array[0..4] of integer;
 leu : integer;
 leud : integer;
 leup : integer;
 leut : integer;
 modifier : integer;
 d : integer;
 ts : integer;

Begin
  ut := unit_info(current_player,cu,unit_type);
  ul := unit_info(current_player,cu,unit_loc);

  leu := 999;
  leud := 9999;

  for x := 0 to 4 do
      if (current_player<>x) then
      Begin
	ceu[x] := closest_enemy_unit(x,ul);
	d := loc_distance(unit_info(current_player,cu,UNIT_LOC),unit_info(x,ceu[x],UNIT_LOC));
	if (d<leud) then
	  Begin
	    leud := d;
	    leu := ceu[x];
	    leup := x;
	    leut := unit_info(leup,leu,UNIT_TYPE);
	  end;
     end;

  ts := treaty_status(current_player,leup);

  if leud<(ailevel div 2) then global_ordertype.orders := OTATTACK_UNIT;

  if (leu=999) and ((ts=WAR) or (ts=NEUTRAL)) then
    Begin
      units[current_player][cu].ordertype := OTATTACK_UNIT;
      case random(8) of
	0 : modifier := -1;
	1 : modifier := 1;
	2 : modifier := -100;
	3 : modifier := 100;
	4 : modifier := 99;
	5 : modifier := -99;
	6 : modifier := 101;
	7 : modifier := -101;
      end;
      units[current_player][cu].destination := unit_info(leup,leu,UNIT_LOC)+modifier;
      units[current_player][cu].destnum := leu;
      units[current_player][cu].pnum := leup;
      attackunit(cu);
    end;
end;

Procedure handle_units;
var
  cua : boolean;
  tmp1,tmp2 : integer;
  return : boolean;
  ul : integer;
  ut : integer;
  current_unit : integer;
Begin
  for current_unit := 0 to MAX_UNITS do   {cycle through all units}
    if (active(current_unit)) then                  {If unit is active, handle the unit}
    Begin
      if units[current_player][current_unit].ordertype=NEED_ORDERTYPE then scan_around(current_unit);
      {BATTLESHIP, CRUISER, DESTROYER, AIRCRAFT_CARRIER}
      ut := unit_info(current_player,current_unit,unit_type);
      if (ut=BATTLESHIP) or (ut=CRUISER) or (ut=DESTROYER) or (ut=AIRCRAFT_CARRIER) then
	Begin
	  scan_around(current_unit);
	  if not(units[current_player][current_unit].ordertype=OTATTACK_UNIT) then explore(current_unit)
	   else attackunit(current_unit);
	end else
      case (units[current_player][current_unit].ordertype) of
	NEED_ORDERTYPE : scan_around(current_unit);
	OTEXPLORE : explore(current_unit);
	OTGOTO_CITY : gotocity(current_unit);
	OTATTACK_CITY : attackcity(current_unit);
	OTATTACK_UNIT : attackunit(current_unit);
	OTSENTRY      : if (unit_info(current_player,current_unit,unit_type)=SEA_TRANSPORT) or
			   (unit_info(current_player,current_unit,unit_type)=AIR_TRANSPORT)  then
			   transport_sentry(current_unit) else sentry(current_unit);
	OTBOARD_TRANSPORT : gototransport(current_unit);
	OTLEAVE_PORT : transportroutine(current_unit);
	OTGOTOLOCATION : gotolocation(current_unit);
      end;
      if (units[current_player][current_unit].ordertype=OTGOTOLOCATION) and
	 (unit_info(current_player,current_unit,UNIT_TRANGE)>0) then
	    gotolocation(current_unit);
      if units[current_player][current_unit].workuntilturn>0 then
	units[current_player][current_unit].workuntilturn := units[current_player][current_unit].workuntilturn-1;
    end;
end;

Procedure Update_Variables;
var
 x,y : integer;
 nco,nuo : integer;
 ratio : array[0..4] of real;
 done : boolean;
 hm : integer;
 lnp,ln : integer;
 n : integer;
Begin
 for x := 0 to MAX_CITIES do
  Begin
    cities[x].owner := city_info(x,OWNER);
    cities[x].oil[stored] := city_info(x,STORED_OIL);
    cities[x].coal[stored] := city_info(x,STORED_COAL);
    cities[x].minerals[stored] := city_info(x,STORED_MINERALS);
    cities[x].gold[stored] := city_info(x,STORED_GOLD);
    cities[x].uranium[stored] := city_info(x,STORED_URANIUM);
    cities[x].food[stored] := city_info(x,STORED_FOOD);
    cities[x].zubles := city_info(x,ZUBLES);
  end;

 {resets unit variables at the beginning of each turn}
 for x := 0 to MAX_UNITS do
     if unit_info(current_player,x,UNIT_ACTIVE)=0 then
	   units[current_player][x].ordertype := NEED_ORDERTYPE;
 {Update turn objective for entire AI}
 for x := 0 to 4 do
   Begin
     player_information[x].num_cities_owned := num_cities(x);
     player_information[x].num_units_owned := num_units(x);
     nco := player_information[current_player].num_cities_owned;
     nuo := player_information[current_player].num_units_owned;
     if nuo>0 then
     ratio[x] := nco/nuo else ratio[x] := 0;
   end;

  if ratio[current_player]>(ailevel div 2) then global_ordertype.orders := OTATTACK_UNIT else
  if ratio[current_player]<=(ailevel div 2) then global_ordertype.orders := OTATTACK_CITY;

  done := false;
  n := 0;
  global_ordertype.enemyrank[4] := current_player;
  ratio[current_player] := 666;

 y := 0;
 for x := 0 to 400 do
   Begin
     rml[x] := y;
     y := y + 1;
     if y>7 then y := 0;
   end;

end;

Procedure Init_game;
var
 x,y : integer;
Begin
 global_ordertype.orders := OTEXPLORE; {default computer into exploration mode}

 {Initialize Units}
 for x := 0 to MAX_UNITS do
  Begin
    units[current_player][x].ordertype := NEED_ORDERTYPE;
    units[current_player][x].workuntilturn := 0;
    units[current_player][x].groupwith := MAX_UNITS+1;
    units[current_player][x].destination := 0;
    units[current_player][x].lastlocation := 0;
    units[current_player][x].destnum := 0;
    units[current_player][x].enroute := 0;
    units[current_player][x].guard_city := 0;
  end;

 {Initialize City info}
 for x := 0 to MAX_CITIES do
  Begin
    cities[x].owner := city_info(x,OWNER);
    cities[x].location := city_info(x,LOCATION);
    cities[x].port_city := (city_info(x,PORT_CITY)=1);
    cities[x].curprod := 0;
    cities[x].oil[access] := city_info(x,ACCESS_OIL);
    cities[x].coal[access] := city_info(x,ACCESS_COAL);
    cities[x].minerals[access] := city_info(x,ACCESS_MINERALS);
    cities[x].gold[access] := city_info(x,ACCESS_GOLD);
    cities[x].uranium[access] := city_info(x,ACCESS_URANIUM);
    cities[x].food[access] := city_info(x,ACCESS_FOOD);
    cities[x].oil[stored] := city_info(x,STORED_OIL);
    cities[x].coal[stored] := city_info(x,STORED_COAL);
    cities[x].minerals[stored] := city_info(x,STORED_MINERALS);
    cities[x].gold[stored] := city_info(x,STORED_GOLD);
    cities[x].uranium[stored] := city_info(x,STORED_URANIUM);
    cities[x].food[stored] := city_info(x,STORED_FOOD);
    cities[x].zubles := city_info(x,ZUBLES);
    for y := 1 to 10 do
      cities[x].production[y] := 0;
  end;
 y := 0;
 for x := 0 to 400 do
   Begin
     rml[x] := y;
     y := y + 1;
     if y>7 then y := 0;
   end;

 {Initial Production Values in Percentages of forces -
  This can be modified throughout gameplay}
  production[infantry]         := 12;
  production[tank]             := 25;
  production[bomber]           := 15;
  production[sub]              := 2;
  production[fighter]          := 16;
  production[sea_transport]    := 5;
  production[air_transport]    := 1;
  production[spy]              := 1;
  production[destroyer]        := 3;
  production[battleship]       := 5;
  production[cruiser]          := 4;
  production[engineer]         := 1;
  production[paratrooper]      := 5;
  production[aircraft_carrier] := 6;

  resources[rgold] := 125;
  resources[rfood] := 200;
  resources[rcoal] := 125;
  resources[ruranium] := 150;
  resources[rminerals] := 125;
  resources[roil] := 125;
end;

Begin
  current_player := player; {store the player that is being called}
  turn := turn_number;  {store the current turn number}
  if (turn=0) then init_game;
  update_variables;
  handle_production;
  handle_global_market;
  handle_buying_units;
  handle_units;  {assigns & executes ordertypes}
end.

